'  ******************************************************************
'  ******************************************************************
' 
' Run CL NomSerie Desde Medio Hasta Prediccin 
'                  %0        %1     %2     %3       %4			 
'  ******************************************************************
'  ******************************************************************


'***************************** TENDENCIA
mode ver4
SERIES %0

smpl %1 %3
LS %0 %0
!L=@REGOBS		' longitud total
smpl %1 %2
LS %0 %0
!L1=@REGOBS		' longitud 1 tendencia
smpl %2 %3
LS %0 %0
!L2=@REGOBS		' longitud 2 tendencia
!filas=@sqr(@floor(!L/4+0.5))+1
!contador=1

!num=1		' *********************************************** bucle de nmero de datos
	!long=!L-(!num-1)*2		' longitud de datos
	!NumEsp=1+2*(!num-1)		' nmero de espectros para cada nmero de datos
	!Deli=!L-!long					' nmero de datos eliminados
		for !numero=1 to !NumEsp		' bucle de espectros para cada nmero de datos

		!t1solo=0
		!t2solo=0

		MATRIX(2,1) DATOS
		!desp2=!numero-1				' desplazamiento de la 2 tendencia
		!desp1=!NumEsp-!numero		' desplazamientos de la primera tendencia
		!L11=!L1-!desp1					' longitud verdadera de la primera tendencia
		!L22=!L2-!desp2					' longitud verdadera de la segunda tendencia
	
		%T="T"+@LEFT(%0,12)		' nombre de la tendencia
		SERIES %T
		%C="C"+@LEFT(%0,12)		' mombre del ciclo
		SERIES %C	

			if !L11>1 then 
				SMPL %1+!desp1 %2
				sample s1.set %1+!desp1 %2
					if !L11>!long-1 then
						!L11=!long
						!t1solo=1	
						!esp11=!desp1+!L11-1
						SMPL %1+!desp1 %1+!esp11
						d s1
						sample s1.set %1+!desp1 %1+!esp11				
					endif

				vector(!L11,1) se


				series da
				da=%0

				se=@convert(da,s1)

				DATOS(1,1)=se(1)
				DATOS(2,1)=se(!L11)



				SMPL %1-%4 %2+%4
				
				GENR T=@TREND(%1)+1-!desp1
						

				GENR %T=DATOS(1,1)-(DATOS(2,1)-DATOS(1,1))/(!L11-1)+((DATOS(2,1)-DATOS(1,1))/(!L11-1))*T

				SMPL %1-%4 %2

					if !L11>!long-1 then
						SMPL %1-%4 %2+%4					
					endif

				GENR %C=%0-%T

				d datos
				d se
				d da
				d s1
			endif
	
		
		' ************************* HAGO LA SEGUNDA TENDENCIA
		if !L22>1 then
			!t2solo=0 

				MATRIX(2,1) DATOS
		
				SMPL %2 %3-!desp2
				sample s1.set %2 %3-!desp2
					if !L22>!long-1 then
							!L22=!long
							!t2solo=1	
							!esp22=!desp2+!L22-1
							SMPL %3-!esp22 %3-!desp2
							d s1
							sample s1.set %3-!esp22 %3-!desp2	
					endif

					vector(!L22,1) se


				series da
				da=%0
 				se=@convert(da)

				DATOS(1,1)=se(1)
				DATOS(2,1)=se(!L22)

				SMPL %2 %3+%4
				
				GENR T=@TREND(%2)+1

						if !t2solo=1 then
							smpl %1-%4 %3+%4
							GENR T=@TREND(%3)+1+!esp22											
						endif

				GENR %T=DATOS(1,1)-(DATOS(2,1)-DATOS(1,1))/(!L22-1)+((DATOS(2,1)-DATOS(1,1))/(!L22-1))*T
				SMPL %2 %3+%4

						if !t2solo=1 then
							SMPL %1-%4 %3+%4					
						endif
				GENR %C=%0-%T

				d datos
				d se
				d da
				d s1
		
	endif

		' ************************************  FIN DE LA SEGUNDA TENDENCIA


		'  ******************************************************************
		'  ******************************************************************
		' 
		' ESPECTRO

		' 
		'  ******************************************************************
		'  ******************************************************************

		!nnnn=!numero-1
		!elimina=!Deli-!nnnn
		!eli1=!Deli-!nnnn-1
		!dddd=!long-!nnnn
		!PI=3.141592654
		smpl %1-%4 %3+%4
		GENR T=@TREND(%1)+1+!elimina

		!PI=3.141592654

			MATRIX(!long/2,4) es{!Deli}d{!nnnn}

 			SMPL %1+!elimina %3-!nnnn

			%NUEVA=@LEFT(%C,4)+"_Y_A"
			GENR %NUEVA=%C-@MEAN(%C)

			!contador=!contador+1
			'matrix(1,2) mayor
			matrix(!long/2,3) picos
			matrix(!long/2,2) coe
			matrix(!long/2,3) picos1
			'matrix(!long/2,2) m5
			'matrix(!long/2,2) m5p1
			'matrix(!long/2,2) m5p

			vector(!L) dd
			'mayor(1,2)=0
			!picc=0
			!pic1c=0
			'!m5c=0
			'!m5p=0
			'!m5p1=0

					
 		FOR !P=1 TO !long/2
			
			LS %NUEVA SIN(((2*!PI*!P)/(!long))*T) COS(((2*!PI*!P)/(!long))*T)
			
				if !P=!long/2 then
					LS %NUEVA COS(((2*!PI*!P)/(!long))*T)
				endif
				
			es{!Deli}d{!nnnn}(!P,1)=!long/!P
			es{!Deli}d{!nnnn}(!P,2)=@R2*100
			coe(!p,1)=c(1)
			coe(!p,2)=c(2)

			' ******************************** mayor contribucin a la varianza
			'if mayor(1,2)<@R2*100 then

			'	mayor(1,1)=!P
			'	mayor(1,2)=@R2*100

			'endif

			' ******************************** ms del 5% de contribucin a la varianza
			'if @R2*100>5 then	

			'	!m5c=!m5c+1
			'	!m5p=!m5p+1
			'	!m5p1=!m5p1+1
			'	m5(!m5c,1)=!P
			'	m5(!m5c,2)=@R2*100
			'	m5p(!m5c,1)=!P
			'	m5p(!m5c,2)=@R2*100
			'	m5p1(!m5c,1)=!P
			'	m5p1(!m5c,2)=@R2*100
			'endif

			' ******************************** picos en la contribucin a la varianza		
			if !P>2 then
				if (es{!Deli}d{!nnnn}(!p-2,2)<es{!Deli}d{!nnnn}(!p-1,2)) and (es{!Deli}d{!nnnn}(!p-1,2)>@R2*100) then
								
				!picc=!picc+1
				picos(!picc,1)=!p-1
				picos(!picc,2)=es{!Deli}d{!nnnn}(!p-1,2)
				picos(!picc,3)=(!long)/(!p-1)

			'			if @R2*100<5 then
			'					!m5p=!m5p+1					
			'					m5p(!m5p,1)=!p-1
			'					m5p(!m5p,2)=es{!Deli}d{!nnnn}(!p-1,2)
			'			endif
				

					if es{!Deli}d{!nnnn}(!p-1,2)>1 then

						!pic1c=!pic1c+1
						picos1(!pic1c,1)=!p-1
						picos1(!pic1c,2)=es{!Deli}d{!nnnn}(!p-1,2)
						picos1(!pic1c,3)=(!long)/(!p-1)

			'			if @R2*100<5 then
			'					!m5p1=!m5p1+1					
			'					m5p1(!m5p1,1)=!p-1
			'					m5p1(!m5p1,2)=es{!Deli}d{!nnnn}(!p-1,2)
			'			endif

					endif

				endif	
				
			endif	
		
		NEXT
		' ******************************** espectro consistente **********************************


	es{!Deli}d{!nnnn}(1,3)=0.54*es{!Deli}d{!nnnn}(1,2)+0.46*es{!Deli}d{!nnnn}(2,2)
			
	FOR !P=2 TO !long/2-1
		es{!Deli}d{!nnnn}(!P,3)=0.23*es{!Deli}d{!nnnn}(!P-1,2)+0.23*es{!Deli}d{!nnnn}(!P+1,2)+0.54*es{!Deli}d{!nnnn}(!P,2)
	next	

	es{!Deli}d{!nnnn}(!long/2,3)=0.54*es{!Deli}d{!nnnn}(!long/2,2)+0.46*es{!Deli}d{!nnnn}(!long/2-1,2)

		'____________________________________________________________________________________

	es{!Deli}d{!nnnn}(1,4)=(3/9)*es{!Deli}d{!nnnn}(1,2)+(4/9)*es{!Deli}d{!nnnn}(2,2)+(2/9)*es{!Deli}d{!nnnn}(3,2)
	es{!Deli}d{!nnnn}(2,4)=(3/9)*es{!Deli}d{!nnnn}(2,2)+(3/9)*es{!Deli}d{!nnnn}(1,2)+(2/9)*es{!Deli}d{!nnnn}(3,2)+(1/9)*es{!Deli}d{!nnnn}(4,2)
			
	FOR !P=3 TO !long/2-2
		es{!Deli}d{!nnnn}(!P,4)=(1/9)*es{!Deli}d{!nnnn}(!P-2,2)+(2/9)*es{!Deli}d{!nnnn}(!P-1,2)+(3/9)*es{!Deli}d{!nnnn}(!P,2)+(2/9)*es{!Deli}d{!nnnn}(!P+1,2)+(1/9)*es{!Deli}d{!nnnn}(!P+2,2)
	next	

	es{!Deli}d{!nnnn}(!long/2,4)=(3/9)*es{!Deli}d{!nnnn}(!long/2,2)+(4/9)*es{!Deli}d{!nnnn}(!long/2-1,2)+(2/9)*es{!Deli}d{!nnnn}(!long/2-2,2)
	es{!Deli}d{!nnnn}(!long/2-1,4)=(3/9)*es{!Deli}d{!nnnn}(!long/2,2)+(3/9)*es{!Deli}d{!nnnn}(!long/2-1,2)+(2/9)*es{!Deli}d{!nnnn}(!long/2-2,2)+(1/9)*es{!Deli}d{!nnnn}(!long/2-3,2)


	
		' ******************************** picos en la contribucin a la varianza 1ER armnico		

	if es{!Deli}d{!nnnn}(1,2)>es{!Deli}d{!nnnn}(2,2) then

		!picc=!picc+1
		picos(!picc,1)=1
		picos(!picc,2)=es{!Deli}d{!nnnn}(1,2)
		picos(!picc,3)=!long
				
			'			if es{!Deli}d{!nnnn}(1,2)<5 then
			'					!m5p=!m5p+1					
			'					m5p(!m5p,1)=1
			'					m5p(!m5p,2)=es{!Deli}d{!nnnn}(1,2)
			'			endif

			if es{!Deli}d{!nnnn}(1,2)>1 then

				!pic1c=!pic1c+1
				picos1(!pic1c,1)=1
				picos1(!pic1c,2)=es{!Deli}d{!nnnn}(1,2)
				picos1(!pic1c,3)=!long

			'			if es{!Deli}d{!nnnn}(1,2)<5 then
			'					!m5p1=!m5p1+1					
			'					m5p1(!m5p1,1)=1
			'					m5p1(!m5p1,2)=es{!Deli}d{!nnnn}(1,2)
			'			endif


			endif

	endif		
	
'*********************** ultimo

	if es{!Deli}d{!nnnn}(!long/2,2)>es{!Deli}d{!nnnn}(!long/2-1,2) then

		!picc=!picc+1
		picos(!picc,1)=!long/2
		picos(!picc,2)=es{!Deli}d{!nnnn}(!long/2,2)
		picos(!picc,3)=2
		
			'			if es{!Deli}d{!nnnn}(!long/2,2)<5 then
			'					!m5p=!m5p+1					
			'					m5p(!m5p,1)=!long/2
			'					m5p(!m5p,2)=es{!Deli}d{!nnnn}(!long/2,2)
			'			endif

			if es{!Deli}d{!nnnn}(!long/2,2)>1 then

				!pic1c=!pic1c+1
				picos1(!pic1c,1)=!long/2
				picos1(!pic1c,2)=es{!Deli}d{!nnnn}(!long/2,2)
				picos1(!pic1c,3)=2

			'			if es{!Deli}d{!nnnn}(!long/2,2)<5 then
			'					!m5p1=!m5p1+1					
			'					m5p1(!m5p1,1)=!long/2
			'					m5p1(!m5p1,2)=es{!Deli}d{!nnnn}(!long/2,2)
			'			endif

			endif

	endif	
	
	' *********************************  todos
matrix(!long,3) txy
LS %NUEVA SIN(((2*!PI)/(!long-1+1))*T) COS(((2*!PI)/(!long-1+1))*T)
txy(1,1)=!long-1+1
txy(1,2)=@R2*100

LS %NUEVA SIN(((2*!PI)/(!long-2+1))*T) COS(((2*!PI)/(!long-2+1))*T)
txy(2,1)=!long-2+1
txy(2,2)=@R2*100

if txy(1,2)>txy(2,2) then
	txy(1,3)=1111111
endif

FOR !P=3 TO !long-2
	
	LS %NUEVA SIN(((2*!PI)/(!long-!p+1))*T) COS(((2*!PI)/(!long-!p+1))*T)
	txy(!P,1)=!long-!p+1
	txy(!P,2)=@R2*100
	if txy(!P-1,2)>txy(!P-2,2) and txy(!P-1,2)>txy(!P,2) then
		txy(!P-1,3)=1111111
	endif
	
NEXT

LS %NUEVA COS(((2*!PI)/(!long-(!long-1)+1))*T)
txy(!long-1,1)=2
txy(!long-1,2)=@R2*100

if txy(!long-1,2)>txy(!long-2,2) then
	txy(!long-1,3)=1111111
endif

if txy(!long-2,2)>txy(!long-3,2) and txy(!long-2,2)>txy(!long-1,2) then
	txy(!long-2,3)=1111111
endif

	'*****************************    TABLA    *********************************************	

	'**************************** estimaciones   ******************************************
	genr m2=@MEAN(%C)	
	smpl %1-%4 %3+%4

	vector media = @convert(m2)	
	d m2
'  ******************************     estimacin picos
	!R2P=0
	series ep_{!Deli}d{!nnnn}
	genr ep_{!Deli}d{!nnnn}=0
	for !p=1 to !picc
			!R2P=!R2P+picos(!p,2)
			!b=picos(!p,1)
			if picos(!p,2)>0.00001 then
				GENR armo=coe(!b,1)*SIN(((2*!PI*!b)/(!long))*T)+coe(!b,2)*COS(((2*!PI*!b)/(!long))*T)
				
				!AA=@FLOOR(!long/picos(!p,1))
				!AAA=@FLOOR((!long/picos(!p,1))*100-!AA*100)
				%ciclo111=@str(!AA)+"_"+@str(!AAA)
				%ciclo1=@LEFT(%0,12)+"clo"+%ciclo111
				genr %ciclo1=armo+MEDIA(1)
				genr ep_{!Deli}d{!nnnn}=ep_{!Deli}d{!nnnn}+armo
			endif
	next
	genr ep_{!Deli}d{!nnnn}=ep_{!Deli}d{!nnnn}+media(1)		

	%otro="ep_"+@LEFT(%0,12)		' mombre 
	r ep_{!Deli}d{!nnnn} %otro
	'%MEDIAA="MED"+@LEFT(%0,12)
	'genr %MEDIAA=1
	'genr %MEDIAA=%MEDIAA*media(1)
'  ******************************     estimacin m5picos
	'!R2P=0
	'series em5p_{!Deli}d{!nnnn}
	'genr em5p_{!Deli}d{!nnnn}=0
	'for !p=1 to !m5p
	'	!R2P=!R2P+m5p(!p,2)
	'	!b=m5p(!p,1)
	'		if m5p(!p,2)>0.00001 then
	'			GENR armo=coe(!b,1)*SIN(((2*!PI*!b)/(!long))*T)+coe(!b,2)*COS(((2*!PI*!b)/(!long))*T)		
	'			genr em5p_{!Deli}d{!nnnn}=em5p_{!Deli}d{!nnnn}+armo
	'		endif
	'next
	'genr em5p_{!Deli}d{!nnnn}=em5p_{!Deli}d{!nnnn}+media(1)		

	'%otro="em5p_"+@LEFT(%0,12)+@str(!Deli)+"D"+@str(!nnnn)		' mombre 
	'r em5p_{!Deli}d{!nnnn} %otro


'  ******************************     estimacin picos1
	!R2P1=0
	series ep1_{!Deli}d{!nnnn}
	genr ep1_{!Deli}d{!nnnn}=0
	for !p=1 to !pic1c
		
			!R2P1=!R2P1+picos1(!p,2)
			!b=picos1(!p,1)
			GENR armo=coe(!b,1)*SIN(((2*!PI*!b)/(!long))*T)+coe(!b,2)*COS(((2*!PI*!b)/(!long))*T)		
			genr ep1_{!Deli}d{!nnnn}=ep1_{!Deli}d{!nnnn}+armo
	next
	genr ep1_{!Deli}d{!nnnn}=ep1_{!Deli}d{!nnnn}+media(1)		

	%otro="ep1_"+@LEFT(%0,12)		' mombre 
	r ep1_{!Deli}d{!nnnn} %otro

'  ******************************     estimacin m5p1
	'!R2P=0
	'series em5p1_{!Deli}d{!nnnn}
	'genr em5p1_{!Deli}d{!nnnn}=0
	'for !p=1 to !m5p1
	'	if m5p1(!p,2)>0.00001 then
	'		!R2P=!R2P+m5p1(!p,2)
	'		!b=m5p1(!p,1)
	'		GENR armo=coe(!b,1)*SIN(((2*!PI*!b)/(!long))*T)+coe(!b,2)*COS(((2*!PI*!b)/(!long))*T)		
	'		genr em5p1_{!Deli}d{!nnnn}=em5p1_{!Deli}d{!nnnn}+armo
	'	endif
	'next
	'genr em5p1_{!Deli}d{!nnnn}=em5p1_{!Deli}d{!nnnn}+media(1)		

	'%otro="em5p1_"+@LEFT(%0,12)+@str(!Deli)+"D"+@str(!nnnn)		' mombre 
	'r em5p1_{!Deli}d{!nnnn} %otro

'  ******************************     estimacin m5
	'!R2M5=0
	'series em5_{!Deli}d{!nnnn}
	'genr em5_{!Deli}d{!nnnn}=0
	'for !p=1 to !m5c
	'		!R2M5=!R2M5+m5(!p,2)
	'		!b=m5(!p,1)
	'		GENR armo=coe(!b,1)*SIN(((2*!PI*!b)/(!long))*T)+coe(!b,2)*COS(((2*!PI*!b)/(!long))*T)		
	'		genr em5_{!Deli}d{!nnnn}=em5_{!Deli}d{!nnnn}+armo
	'next
	'genr em5_{!Deli}d{!nnnn}=em5_{!Deli}d{!nnnn}+media(1)		

	'%otro="em5_"+@LEFT(%0,12)+@str(!Deli)+"D"+@str(!nnnn)		' mombre 
	'r em5_{!Deli}d{!nnnn} %otro


'  ******************************     estimacin mayor ciclo

	'!b=mayor(1,1)
	'series emas_{!Deli}d{!nnnn}
	'GENR armo=coe(!b,1)*SIN(((2*!PI*!b)/(!long))*T)+coe(!b,2)*COS(((2*!PI*!b)/(!long))*T)		
	'genr emas_{!Deli}d{!nnnn}=armo+media(1)

	'%otro="emas_"+@LEFT(%0,12)+@str(!Deli)+"D"+@str(!nnnn)		' mombre 
	'r emas_{!Deli}d{!nnnn} %otro

		
'  ******************************     
	%otro="es"+@LEFT(%0,12)		' mombre 
	%otroo="est"+@LEFT(%0,12)
	%otro1="esP"+@LEFT(%0,12)
	%otro2="esP1"+@LEFT(%0,12)
	%otro3="e_"+@LEFT(%0,12)
	%otro4="e1_"+@LEFT(%0,12)
	%otro5="e2_"+@LEFT(%0,12)

	r es{!Deli}d{!nnnn} %otro
	r picos %otro1
	r picos1 %otro2
	r txy %otroo

		series col1
		series col2
		series col3
		series col4
		group g1 col1 col2 col3 col4
		sample s1.set %1 %1+!long/2-1
		mtos(%otro,g1,s1)		
		d col1
	
		d s1
	r col2 %otro3
	r col4 %otro5
	r col3 %otro4
	
			SERIES I
			SERIES ANOS
			D I
			D ANOS
			D %NUEVA
		'	D %T	
			D COE
			D DD
			D MEDIA
			D ARMO
		'  	D DATOS
			d g1
	next

